﻿using EnvelopeCreatorProject.DocusignAPI;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;

namespace EnvelopeCreator.Converters
{
    public class RecipientConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
        {
            var recipient = (Recipient)value;

            var obj = new ExpandoObject();

            Type GetStaticType<T>(T x) => typeof(T);

            var props = GetStaticType(recipient).GetProperties().Select(p => new { p.Name, Value = p.GetValue(recipient) });

            var dict = obj as IDictionary<string, object>;

            foreach (var prop in props)
            {
                dict.Add(prop.Name, prop.Value);
            }

            var raw = JsonConvert.SerializeObject(obj);

            writer.WriteRawValue(raw);
        }

        public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer)
        {
            var jobj = JObject.Load(reader);

            var recipient = new Recipient();

            recipient.SendType = jobj["SendType"].Value<string>();

            recipient.BuildRecipient();

            JsonConvert.PopulateObject(jobj.ToString(), recipient);

            return recipient;
        }

        public override bool CanWrite {  get => true; }

        public override bool CanConvert(Type objectType) => true;
    }
}
