﻿using System;
using System.Net;
using Microsoft.Extensions.Logging;

namespace EnvelopeCreatorProject.Models.Signers
{
    public class SOBOSigner : OAuthSigner
    {
        public SOBOSigner(ILogger<OAuthSigner> logger) : base(logger)
        {
        }

        public string SenderToken { get; set; }
        public string SenderMail { get; set; }

        internal override void SetHeaderCollection(HttpWebRequest request)
        {
            request.Headers.Add("Authorization", "bearer " + this.SenderToken);
            request.Headers.Add("X-DocuSign-Act-As-User", this.SenderMail);
            
        }

        protected override bool ValidateAuthInfo()
        {
            return !String.IsNullOrEmpty(SenderToken) && !String.IsNullOrEmpty(SenderMail) && base.ValidateAuthInfo();
        }
    }
}
